package com.tzld.piaoquan.longarticle.service.local.impl;

import com.tzld.piaoquan.longarticle.dao.mapper.PublishContentMapper;
import com.tzld.piaoquan.longarticle.model.dto.PublishArticleData;
import com.tzld.piaoquan.longarticle.model.po.PlanAccount;
import com.tzld.piaoquan.longarticle.model.po.PublishContent;
import com.tzld.piaoquan.longarticle.model.po.PublishContentExample;
import com.tzld.piaoquan.longarticle.utils.DateUtil;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.Arrays;
import java.util.List;

@Service
public class PublicContentServiceImpl {

    @Autowired
    private PublishContentMapper publishContentMapper;

    public int getSendCount(Long planAccountId) {
        PublishContentExample example = new PublishContentExample();
        example.createCriteria().andStatusIn(Arrays.asList(1, 2))
                .andCreateTimeGreaterThan(DateUtil.getThatDayDate())
                .andPlanAccountIdEqualTo(planAccountId);
        long sendCount = publishContentMapper.countByExample(example);
        return (int) sendCount;
    }

    public PublishContent getPublishContent(PlanAccount planAccount, PublishArticleData publishArticleData) {
        String publishContentId = publishArticleData.getId();
        if (StringUtils.isEmpty(publishContentId)) {
            return null;
        }
        PublishContentExample example = new PublishContentExample();
        example.createCriteria().andPublishContentIdEqualTo(publishContentId);
        List<PublishContent> publishContents = publishContentMapper.selectByExample(example);
        if (!CollectionUtils.isEmpty(publishContents)) {
            PublishContent publishContent = publishContents.get(0);
            publishContent.setStatus(0);
            publishContentMapper.updateByPrimaryKeySelective(publishContent);
            return publishContent;
        }
        PublishContent publishContent = new PublishContent();
        publishContent.setPlanAccountId(planAccount.getId());
        publishContent.setPublishContentId(publishArticleData.getId());
        publishContent.setSourceId(publishArticleData.getSourceId());
        publishContent.setScore(publishArticleData.getScore());
        publishContent.setContentPoolType(publishArticleData.getContentPoolType());
        publishContentMapper.insertSelective(publishContent);
        return publishContent;
    }
}
