package com.tzld.piaoquan.longarticle.service.remote.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.tzld.piaoquan.longarticle.model.dto.MiniprogramCardRequest;
import com.tzld.piaoquan.longarticle.service.remote.MatchService;
import com.tzld.piaoquan.longarticle.utils.HttpClientUtil;
import com.tzld.piaoquan.longarticle.utils.HttpPoolClientUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

@Slf4j
@Service
public class MatchServiceImpl implements MatchService {

    private static final HttpPoolClientUtil HTTP_POOL_CLIENT_UTIL_DEFAULT = HttpClientUtil.create(3000, 6000, 20, 100, 3, 3000);


    @Override
    public String matchMiniprogramVideo(MiniprogramCardRequest request) {
        String apiUrl = "http://47.99.132.47:8111/search_videos";
        try {
            String res = HTTP_POOL_CLIENT_UTIL_DEFAULT.post(apiUrl, JSON.toJSONString(request));
            JSONObject jsonObject = JSON.parseObject(res);
            Integer code = jsonObject.getInteger("code");
            if (code == 0) {
                return jsonObject.getString("traceId");
            }
        } catch (Exception e) {
            log.error("matchMiniprogramVideo error", e);
        }
        return "";
    }
}
